"""
Convenience module to do "from virgotools.all import *" in throwaway scripts.
Please refrain from doing wildcard imports for serious work, you will regret
it later. Note that from "virgotools import *" is deprecated, since this makes
it hard to intall PythonVirgoTools outside of Cascina, where e.g. Cm or Tango
might not be needed.
"""


# Python stdlib
import logging

# import all functions defined by __all__ in sub-modules and make a new __all__

_before = set(dir())
import PyFd as fd
import PyCm as cm
from virgotools.cm_lib import *
from virgotools.cfg_lib import *
from virgotools.frame_lib import *
from virgotools.connect_online import *
from virgotools.gpstime import *
from virgotools.virgo_logging import *
from virgotools.interface_DSP import *
from virgotools.interface_acl import *
from virgotools.interface_tango import *
from virgotools.vpm import *

_after = set(dir())
__all__ = list(_after - _before - {'_before'}) + ['log', 'logger']

logger = logging.getLogger('user')


# FIXME: deprecate log, it clashes with math.log and np.log
class DeprecatedLog(object):
    def __init__(self):
        self._warned = False

    def __getattr__(self, attr):
        if not self._warned:
            logger.warn('virgotools.log is deprecated, use virgotools.logger instead')
            self._warned = True
        return getattr(logger, attr)
log = DeprecatedLog()
